Index: c/src/exec/rtems/include/Makefile.in
===================================================================
--- c/src/exec/rtems/include/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/rtems/include/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=wrap rtems
Index: c/src/exec/rtems/include/rtems/Makefile.in
===================================================================
--- c/src/exec/rtems/include/rtems/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/rtems/include/rtems/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems
Index: c/src/exec/rtems/inline/Makefile.in
===================================================================
--- c/src/exec/rtems/inline/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/rtems/inline/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems
Index: c/src/exec/rtems/inline/rtems/Makefile.in
===================================================================
--- c/src/exec/rtems/inline/rtems/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/rtems/inline/rtems/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems
Index: c/src/exec/rtems/macros/Makefile.in
===================================================================
--- c/src/exec/rtems/macros/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/rtems/macros/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems
Index: c/src/exec/rtems/macros/rtems/Makefile.in
===================================================================
--- c/src/exec/rtems/macros/rtems/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/rtems/macros/rtems/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems
Index: c/src/exec/sapi/inline/Makefile.in
===================================================================
--- c/src/exec/sapi/inline/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/sapi/inline/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems
Index: c/src/exec/sapi/macros/Makefile.in
===================================================================
--- c/src/exec/sapi/macros/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
+++ c/src/exec/sapi/macros/Makefile.in	(revision 646879b244a368ed96bd25a5ee632571c536f16e)
@@ -0,0 +1,14 @@
+#
+#  $Id$
+#
+
+@SET_MAKE@
+srcdir = @srcdir@
+VPATH = @srcdir@
+RTEMS_ROOT = @top_srcdir@
+PROJECT_ROOT = @PROJECT_ROOT@
+
+include $(RTEMS_ROOT)/make/custom/$(RTEMS_BSP).cfg
+include $(RTEMS_ROOT)/make/directory.cfg
+
+SUB_DIRS=rtems