Index: configure
===================================================================
--- configure	(revision e5f4e5aaff76424f6977d9938cb6ffa10e24f354)
+++ configure	(revision 710389fcca57f5a5c123d579c5e93d7e4719573e)
@@ -3496,6 +3496,4 @@
 
 
-PROJECT_ROOT=`pwd;`
-
 # If RTEMS macros are enabled, then use them.  Otherwise, use inlines.
 if test "$RTEMS_USE_MACROS" = "yes"; then
@@ -3511,10 +3509,10 @@
 # If the TCP/IP stack is enabled, then find all TCP/IP Makefiles
 echo $ac_n "checking if networking is enabled? ""... $ac_c" 1>&6
-echo "configure:3514: checking if networking is enabled? " >&5
+echo "configure:3512: checking if networking is enabled? " >&5
 echo "$ac_t""$RTEMS_HAS_NETWORKING" 1>&6
 if test "$RTEMS_HAS_NETWORKING" = "yes"; then
   
 echo $ac_n "checking for Makefile.in in c/src/lib/libnetworking""... $ac_c" 1>&6
-echo "configure:3519: checking for Makefile.in in c/src/lib/libnetworking" >&5
+echo "configure:3517: checking for Makefile.in in c/src/lib/libnetworking" >&5
 if test -d $srcdir/c/src/lib/libnetworking; then
   rtems_av_save_dir=`pwd`;
@@ -3531,5 +3529,5 @@
   
 echo $ac_n "checking for Makefile.in in c/src/lib/librpc""... $ac_c" 1>&6
-echo "configure:3534: checking for Makefile.in in c/src/lib/librpc" >&5
+echo "configure:3532: checking for Makefile.in in c/src/lib/librpc" >&5
 if test -d $srcdir/c/src/lib/librpc; then
   rtems_av_save_dir=`pwd`;
@@ -3546,5 +3544,5 @@
   if test "$RTEMS_HAS_RDBG" = "yes"; then
     echo $ac_n "checking whether cpu supports rdbg? ""... $ac_c" 1>&6
-echo "configure:3549: checking whether cpu supports rdbg? " >&5
+echo "configure:3547: checking whether cpu supports rdbg? " >&5
     test ! -d "$srcdir/c/src/lib/librdbg/$target_cpu" && RTEMS_HAS_RDBG="no" ;
     echo "$ac_t""$RTEMS_HAS_RDBG" 1>&6
@@ -3553,5 +3551,5 @@
 set dummy rpcgen; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3556: checking for $ac_word" >&5
+echo "configure:3554: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_path_RPCGEN'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3593,5 +3591,5 @@
 set dummy $ac_prog; ac_word=$2
 echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
-echo "configure:3596: checking for $ac_word" >&5
+echo "configure:3594: checking for $ac_word" >&5
 if eval "test \"`echo '$''{'ac_cv_prog_AWK'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -3627,5 +3625,5 @@
       
 echo $ac_n "checking for Makefile.in in c/src/lib/librdbg""... $ac_c" 1>&6
-echo "configure:3630: checking for Makefile.in in c/src/lib/librdbg" >&5
+echo "configure:3628: checking for Makefile.in in c/src/lib/librdbg" >&5
 if test -d $srcdir/c/src/lib/librdbg; then
   rtems_av_save_dir=`pwd`;
@@ -3654,5 +3652,5 @@
 # If the tests are enabled, then find all the test suite Makefiles
 echo $ac_n "checking if the test suites are enabled? ""... $ac_c" 1>&6
-echo "configure:3657: checking if the test suites are enabled? " >&5
+echo "configure:3655: checking if the test suites are enabled? " >&5
 tests_enabled=yes
 # Check whether --enable-tests or --disable-tests was given.
@@ -3672,5 +3670,5 @@
 
 echo $ac_n "checking for Makefile.in in c/src/tests/tools/$target_cpu""... $ac_c" 1>&6
-echo "configure:3675: checking for Makefile.in in c/src/tests/tools/$target_cpu" >&5
+echo "configure:3673: checking for Makefile.in in c/src/tests/tools/$target_cpu" >&5
 if test -d $srcdir/c/src/tests/tools/$target_cpu; then
   rtems_av_save_dir=`pwd`;
@@ -3689,5 +3687,5 @@
    
 echo $ac_n "checking for Makefile.in in c/src/tests/libtests""... $ac_c" 1>&6
-echo "configure:3692: checking for Makefile.in in c/src/tests/libtests" >&5
+echo "configure:3690: checking for Makefile.in in c/src/tests/libtests" >&5
 if test -d $srcdir/c/src/tests/libtests; then
   rtems_av_save_dir=`pwd`;
@@ -3704,5 +3702,5 @@
    
 echo $ac_n "checking for Makefile.in in c/src/tests/sptests""... $ac_c" 1>&6
-echo "configure:3707: checking for Makefile.in in c/src/tests/sptests" >&5
+echo "configure:3705: checking for Makefile.in in c/src/tests/sptests" >&5
 if test -d $srcdir/c/src/tests/sptests; then
   rtems_av_save_dir=`pwd`;
@@ -3719,5 +3717,5 @@
    
 echo $ac_n "checking for Makefile.in in c/src/tests/tmtests""... $ac_c" 1>&6
-echo "configure:3722: checking for Makefile.in in c/src/tests/tmtests" >&5
+echo "configure:3720: checking for Makefile.in in c/src/tests/tmtests" >&5
 if test -d $srcdir/c/src/tests/tmtests; then
   rtems_av_save_dir=`pwd`;
@@ -3735,5 +3733,5 @@
        
 echo $ac_n "checking for Makefile.in in c/src/tests/mptests""... $ac_c" 1>&6
-echo "configure:3738: checking for Makefile.in in c/src/tests/mptests" >&5
+echo "configure:3736: checking for Makefile.in in c/src/tests/mptests" >&5
 if test -d $srcdir/c/src/tests/mptests; then
   rtems_av_save_dir=`pwd`;
@@ -3752,5 +3750,5 @@
      
 echo $ac_n "checking for Makefile.in in c/src/tests/psxtests""... $ac_c" 1>&6
-echo "configure:3755: checking for Makefile.in in c/src/tests/psxtests" >&5
+echo "configure:3753: checking for Makefile.in in c/src/tests/psxtests" >&5
 if test -d $srcdir/c/src/tests/psxtests; then
   rtems_av_save_dir=`pwd`;
@@ -3786,5 +3784,5 @@
 if test "$RTEMS_HAS_HWAPI" = "yes"; then
   echo $ac_n "checking whether libwapi is present""... $ac_c" 1>&6
-echo "configure:3789: checking whether libwapi is present" >&5
+echo "configure:3787: checking whether libwapi is present" >&5
   if test -f ${srcdir}/c/src/lib/libhwapi/Makefile.in ; then
     echo "$ac_t""yes" 1>&6
@@ -3792,5 +3790,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/analog""... $ac_c" 1>&6
-echo "configure:3795: checking for Makefile.in in c/src/lib/libhwapi/analog" >&5
+echo "configure:3793: checking for Makefile.in in c/src/lib/libhwapi/analog" >&5
 if test -d $srcdir/c/src/lib/libhwapi/analog; then
   rtems_av_save_dir=`pwd`;
@@ -3807,5 +3805,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/discrete""... $ac_c" 1>&6
-echo "configure:3810: checking for Makefile.in in c/src/lib/libhwapi/discrete" >&5
+echo "configure:3808: checking for Makefile.in in c/src/lib/libhwapi/discrete" >&5
 if test -d $srcdir/c/src/lib/libhwapi/discrete; then
   rtems_av_save_dir=`pwd`;
@@ -3822,5 +3820,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/drivers""... $ac_c" 1>&6
-echo "configure:3825: checking for Makefile.in in c/src/lib/libhwapi/drivers" >&5
+echo "configure:3823: checking for Makefile.in in c/src/lib/libhwapi/drivers" >&5
 if test -d $srcdir/c/src/lib/libhwapi/drivers; then
   rtems_av_save_dir=`pwd`;
@@ -3837,5 +3835,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/non_volatile_memory""... $ac_c" 1>&6
-echo "configure:3840: checking for Makefile.in in c/src/lib/libhwapi/non_volatile_memory" >&5
+echo "configure:3838: checking for Makefile.in in c/src/lib/libhwapi/non_volatile_memory" >&5
 if test -d $srcdir/c/src/lib/libhwapi/non_volatile_memory; then
   rtems_av_save_dir=`pwd`;
@@ -3852,5 +3850,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/serial""... $ac_c" 1>&6
-echo "configure:3855: checking for Makefile.in in c/src/lib/libhwapi/serial" >&5
+echo "configure:3853: checking for Makefile.in in c/src/lib/libhwapi/serial" >&5
 if test -d $srcdir/c/src/lib/libhwapi/serial; then
   rtems_av_save_dir=`pwd`;
@@ -3867,5 +3865,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/support""... $ac_c" 1>&6
-echo "configure:3870: checking for Makefile.in in c/src/lib/libhwapi/support" >&5
+echo "configure:3868: checking for Makefile.in in c/src/lib/libhwapi/support" >&5
 if test -d $srcdir/c/src/lib/libhwapi/support; then
   rtems_av_save_dir=`pwd`;
@@ -3882,5 +3880,5 @@
     
 echo $ac_n "checking for Makefile.in in c/src/lib/libhwapi/wrapup""... $ac_c" 1>&6
-echo "configure:3885: checking for Makefile.in in c/src/lib/libhwapi/wrapup" >&5
+echo "configure:3883: checking for Makefile.in in c/src/lib/libhwapi/wrapup" >&5
 if test -d $srcdir/c/src/lib/libhwapi/wrapup; then
   rtems_av_save_dir=`pwd`;
@@ -3913,18 +3911,8 @@
 
 
-
-
-
-
-
-
-
-
-
-
 # pick up all the Makefiles in required parts of the tree
 
 echo $ac_n "checking for Makefile.in in make""... $ac_c" 1>&6
-echo "configure:3929: checking for Makefile.in in make" >&5
+echo "configure:3917: checking for Makefile.in in make" >&5
 if test -d $srcdir/make; then
   rtems_av_save_dir=`pwd`;
@@ -3941,5 +3929,5 @@
 
 echo $ac_n "checking for Makefile.in in c/src/lib/libchip""... $ac_c" 1>&6
-echo "configure:3944: checking for Makefile.in in c/src/lib/libchip" >&5
+echo "configure:3932: checking for Makefile.in in c/src/lib/libchip" >&5
 if test -d $srcdir/c/src/lib/libchip; then
   rtems_av_save_dir=`pwd`;
@@ -3956,5 +3944,5 @@
 
 echo $ac_n "checking for Makefile.in in c/src/lib/libmisc""... $ac_c" 1>&6
-echo "configure:3959: checking for Makefile.in in c/src/lib/libmisc" >&5
+echo "configure:3947: checking for Makefile.in in c/src/lib/libmisc" >&5
 if test -d $srcdir/c/src/lib/libmisc; then
   rtems_av_save_dir=`pwd`;
@@ -3971,5 +3959,5 @@
 
 echo $ac_n "checking for Makefile.in in c/src/tests/samples""... $ac_c" 1>&6
-echo "configure:3974: checking for Makefile.in in c/src/tests/samples" >&5
+echo "configure:3962: checking for Makefile.in in c/src/tests/samples" >&5
 if test -d $srcdir/c/src/tests/samples; then
   rtems_av_save_dir=`pwd`;
Index: configure.in
===================================================================
--- configure.in	(revision e5f4e5aaff76424f6977d9938cb6ffa10e24f354)
+++ configure.in	(revision 710389fcca57f5a5c123d579c5e93d7e4719573e)
@@ -292,6 +292,4 @@
 dnl END configure.target.in
 
-PROJECT_ROOT=`pwd;`
-
 # If RTEMS macros are enabled, then use them.  Otherwise, use inlines.
 if test "$RTEMS_USE_MACROS" = "yes"; then
@@ -372,21 +370,11 @@
 fi
 
-AC_SUBST(RTEMS_GAS_CODE16)
 AC_SUBST(rtems_cv_prog_cc_cross)
 AC_SUBST(RTEMS_BSP_LIST)
 AC_SUBST(RTEMS_HOST)
-AC_SUBST(RTEMS_LIBC_DIR)
-AC_SUBST(RTEMS_USE_OWN_PDIR)
-AC_SUBST(RTEMS_HAS_POSIX_API)
-AC_SUBST(RTEMS_HAS_MULTIPROCESSING)
-AC_SUBST(RTEMS_HAS_NETWORKING)
-AC_SUBST(RTEMS_HAS_RDBG)
-AC_SUBST(RTEMS_USE_MACROS)
 AC_SUBST(RTEMS_HAS_CPLUSPLUS)
 AC_SUBST(RTEMS_USE_GCC272)
-AC_SUBST(RTEMS_LIBC_DIR)
 AC_SUBST(BARE_CPU_CFLAGS)
 AC_SUBST(BARE_CPU_MODEL)
-AC_SUBST(PROJECT_ROOT)
 AC_SUBST(program_prefix)
 AC_SUBST(CC_CFLAGS_DEFAULT)